/* shafttab.h - shaft table, for quick look-up of the face pairs
 * which must be joined by a plane. See shaft.c
 */

typedef struct {
	int i1 ;	/* index of one face, 0..5 */
	int i2 ;	/* index of connecting face, 0..5 */
	int i3n ;	/* third index (plane's 0 component), 0..2 */
} intPair ;

typedef struct {
	intPair *pairs;
	int numPairs ;
} planeSetPair ;

static intPair planeSet00[] = { {0,1,2} };	/* really none, but must put something here */
static intPair planeSet01[] = { {0,1,2},
                                {0,2,1},
                                {4,0,2},
                                {5,0,1} };
static intPair planeSet02[] = { {1,0,2},
                                {1,2,0},
                                {3,1,2},
                                {5,1,0} };
static intPair planeSet03[] = { {0,2,1},
                                {4,0,2},
                                {5,0,1},
                                {1,2,0},
                                {3,1,2},
                                {5,1,0} };
static intPair planeSet04[] = { {2,0,1},
                                {2,1,0},
                                {3,2,1},
                                {4,2,0} };
static intPair planeSet05[] = { {0,1,2},
                                {4,0,2},
                                {5,0,1},
                                {2,1,0},
                                {3,2,1},
                                {4,2,0} };
static intPair planeSet06[] = { {1,0,2},
                                {2,0,1},
                                {3,1,2},
                                {5,1,0},
                                {3,2,1},
                                {4,2,0} };
static intPair planeSet07[] = { {4,0,2},
                                {5,0,1},
                                {3,1,2},
                                {5,1,0},
                                {3,2,1},
                                {4,2,0} };
static intPair planeSet08[] = { {1,3,2},
                                {2,3,1},
                                {3,4,2},
                                {3,5,1} };
static intPair planeSet09[] = { {0,1,2},
                                {0,2,1},
                                {4,0,2},
                                {5,0,1},
                                {1,3,2},
                                {2,3,1},
                                {3,4,2},
                                {3,5,1} };
static intPair planeSet10[] = { {1,0,2},
                                {1,2,0},
                                {5,1,0},
                                {2,3,1},
                                {3,4,2},
                                {3,5,1} };
static intPair planeSet11[] = { {0,2,1},
                                {4,0,2},
                                {5,0,1},
                                {1,2,0},
                                {5,1,0},
                                {2,3,1},
                                {3,4,2},
                                {3,5,1} };
static intPair planeSet12[] = { {2,0,1},
                                {2,1,0},
                                {1,3,2},
                                {4,2,0},
                                {3,4,2},
                                {3,5,1} };
static intPair planeSet13[] = { {0,1,2},
                                {4,0,2},
                                {5,0,1},
                                {2,1,0},
                                {1,3,2},
                                {4,2,0},
                                {3,4,2},
                                {3,5,1} };
static intPair planeSet14[] = { {1,0,2},
                                {2,0,1},
                                {5,1,0},
                                {4,2,0},
                                {3,4,2},
                                {3,5,1} };
static intPair planeSet15[] = { {4,0,2},
                                {5,0,1},
                                {5,1,0},
                                {4,2,0},
                                {3,4,2},
                                {3,5,1} };
static intPair planeSet16[] = { {0,4,2},
                                {2,4,0},
                                {4,3,2},
                                {4,5,0} };
static intPair planeSet17[] = { {0,1,2},
                                {0,2,1},
                                {5,0,1},
                                {2,4,0},
                                {4,3,2},
                                {4,5,0} };
static intPair planeSet18[] = { {1,0,2},
                                {0,4,2},
                                {1,2,0},
                                {3,1,2},
                                {5,1,0},
                                {2,4,0},
                                {4,3,2},
                                {4,5,0} };
static intPair planeSet19[] = { {0,2,1},
                                {5,0,1},
                                {1,2,0},
                                {3,1,2},
                                {5,1,0},
                                {2,4,0},
                                {4,3,2},
                                {4,5,0} };
static intPair planeSet20[] = { {2,0,1},
                                {0,4,2},
                                {2,1,0},
                                {3,2,1},
                                {4,3,2},
                                {4,5,0} };
static intPair planeSet21[] = { {0,1,2},
                                {5,0,1},
                                {2,1,0},
                                {3,2,1},
                                {4,3,2},
                                {4,5,0} };
static intPair planeSet22[] = { {1,0,2},
                                {2,0,1},
                                {0,4,2},
                                {3,1,2},
                                {5,1,0},
                                {3,2,1},
                                {4,3,2},
                                {4,5,0} };
static intPair planeSet23[] = { {5,0,1},
                                {3,1,2},
                                {5,1,0},
                                {3,2,1},
                                {4,3,2},
                                {4,5,0} };
static intPair planeSet24[] = { {0,4,2},
                                {1,3,2},
                                {2,3,1},
                                {2,4,0},
                                {3,5,1},
                                {4,5,0} };
static intPair planeSet25[] = { {0,1,2},
                                {0,2,1},
                                {5,0,1},
                                {1,3,2},
                                {2,3,1},
                                {2,4,0},
                                {3,5,1},
                                {4,5,0} };
static intPair planeSet26[] = { {1,0,2},
                                {0,4,2},
                                {1,2,0},
                                {5,1,0},
                                {2,3,1},
                                {2,4,0},
                                {3,5,1},
                                {4,5,0} };
static intPair planeSet27[] = { {0,2,1},
                                {5,0,1},
                                {1,2,0},
                                {5,1,0},
                                {2,3,1},
                                {2,4,0},
                                {3,5,1},
                                {4,5,0} };
static intPair planeSet28[] = { {2,0,1},
                                {0,4,2},
                                {2,1,0},
                                {1,3,2},
                                {3,5,1},
                                {4,5,0} };
static intPair planeSet29[] = { {0,1,2},
                                {5,0,1},
                                {2,1,0},
                                {1,3,2},
                                {3,5,1},
                                {4,5,0} };
static intPair planeSet30[] = { {1,0,2},
                                {2,0,1},
                                {0,4,2},
                                {5,1,0},
                                {3,5,1},
                                {4,5,0} };
static intPair planeSet31[] = { {5,0,1},
                                {5,1,0},
                                {3,5,1},
                                {4,5,0} };
static intPair planeSet32[] = { {0,5,1},
                                {1,5,0},
                                {5,3,1},
                                {5,4,0} };
static intPair planeSet33[] = { {0,1,2},
                                {0,2,1},
                                {4,0,2},
                                {1,5,0},
                                {5,3,1},
                                {5,4,0} };
static intPair planeSet34[] = { {1,0,2},
                                {0,5,1},
                                {1,2,0},
                                {3,1,2},
                                {5,3,1},
                                {5,4,0} };
static intPair planeSet35[] = { {0,2,1},
                                {4,0,2},
                                {1,2,0},
                                {3,1,2},
                                {5,3,1},
                                {5,4,0} };
static intPair planeSet36[] = { {2,0,1},
                                {0,5,1},
                                {2,1,0},
                                {1,5,0},
                                {3,2,1},
                                {4,2,0},
                                {5,3,1},
                                {5,4,0} };
static intPair planeSet37[] = { {0,1,2},
                                {4,0,2},
                                {2,1,0},
                                {1,5,0},
                                {3,2,1},
                                {4,2,0},
                                {5,3,1},
                                {5,4,0} };
static intPair planeSet38[] = { {1,0,2},
                                {2,0,1},
                                {0,5,1},
                                {3,1,2},
                                {3,2,1},
                                {4,2,0},
                                {5,3,1},
                                {5,4,0} };
static intPair planeSet39[] = { {4,0,2},
                                {3,1,2},
                                {3,2,1},
                                {4,2,0},
                                {5,3,1},
                                {5,4,0} };
static intPair planeSet40[] = { {0,5,1},
                                {1,3,2},
                                {1,5,0},
                                {2,3,1},
                                {3,4,2},
                                {5,4,0} };
static intPair planeSet41[] = { {0,1,2},
                                {0,2,1},
                                {4,0,2},
                                {1,3,2},
                                {1,5,0},
                                {2,3,1},
                                {3,4,2},
                                {5,4,0} };
static intPair planeSet42[] = { {1,0,2},
                                {0,5,1},
                                {1,2,0},
                                {2,3,1},
                                {3,4,2},
                                {5,4,0} };
static intPair planeSet43[] = { {0,2,1},
                                {4,0,2},
                                {1,2,0},
                                {2,3,1},
                                {3,4,2},
                                {5,4,0} };
static intPair planeSet44[] = { {2,0,1},
                                {0,5,1},
                                {2,1,0},
                                {1,3,2},
                                {1,5,0},
                                {4,2,0},
                                {3,4,2},
                                {5,4,0} };
static intPair planeSet45[] = { {0,1,2},
                                {4,0,2},
                                {2,1,0},
                                {1,3,2},
                                {1,5,0},
                                {4,2,0},
                                {3,4,2},
                                {5,4,0} };
static intPair planeSet46[] = { {1,0,2},
                                {2,0,1},
                                {0,5,1},
                                {4,2,0},
                                {3,4,2},
                                {5,4,0} };
static intPair planeSet47[] = { {4,0,2},
                                {4,2,0},
                                {3,4,2},
                                {5,4,0} };
static intPair planeSet48[] = { {0,4,2},
                                {0,5,1},
                                {1,5,0},
                                {2,4,0},
                                {4,3,2},
                                {5,3,1} };
static intPair planeSet49[] = { {0,1,2},
                                {0,2,1},
                                {1,5,0},
                                {2,4,0},
                                {4,3,2},
                                {5,3,1} };
static intPair planeSet50[] = { {1,0,2},
                                {0,4,2},
                                {0,5,1},
                                {1,2,0},
                                {3,1,2},
                                {2,4,0},
                                {4,3,2},
                                {5,3,1} };
static intPair planeSet51[] = { {0,2,1},
                                {1,2,0},
                                {3,1,2},
                                {2,4,0},
                                {4,3,2},
                                {5,3,1} };
static intPair planeSet52[] = { {2,0,1},
                                {0,4,2},
                                {0,5,1},
                                {2,1,0},
                                {1,5,0},
                                {3,2,1},
                                {4,3,2},
                                {5,3,1} };
static intPair planeSet53[] = { {0,1,2},
                                {2,1,0},
                                {1,5,0},
                                {3,2,1},
                                {4,3,2},
                                {5,3,1} };
static intPair planeSet54[] = { {1,0,2},
                                {2,0,1},
                                {0,4,2},
                                {0,5,1},
                                {3,1,2},
                                {3,2,1},
                                {4,3,2},
                                {5,3,1} };
static intPair planeSet55[] = { {3,1,2},
                                {3,2,1},
                                {4,3,2},
                                {5,3,1} };
static intPair planeSet56[] = { {0,4,2},
                                {0,5,1},
                                {1,3,2},
                                {1,5,0},
                                {2,3,1},
                                {2,4,0} };
static intPair planeSet57[] = { {0,1,2},
                                {0,2,1},
                                {1,3,2},
                                {1,5,0},
                                {2,3,1},
                                {2,4,0} };
static intPair planeSet58[] = { {1,0,2},
                                {0,4,2},
                                {0,5,1},
                                {1,2,0},
                                {2,3,1},
                                {2,4,0} };
static intPair planeSet59[] = { {0,2,1},
                                {1,2,0},
                                {2,3,1},
                                {2,4,0} };
static intPair planeSet60[] = { {2,0,1},
                                {0,4,2},
                                {0,5,1},
                                {2,1,0},
                                {1,3,2},
                                {1,5,0} };
static intPair planeSet61[] = { {0,1,2},
                                {2,1,0},
                                {1,3,2},
                                {1,5,0} };
static intPair planeSet62[] = { {1,0,2},
                                {2,0,1},
                                {0,4,2},
                                {0,5,1} };
static intPair planeSet63[] = { {0,1,2} };	/* really none, but must put something here */

static planeSetPair planeSetTable[] = {
	{ planeSet00, 0 },
	{ planeSet01, 4 },
	{ planeSet02, 4 },
	{ planeSet03, 6 },
	{ planeSet04, 4 },
	{ planeSet05, 6 },
	{ planeSet06, 6 },
	{ planeSet07, 6 },
	{ planeSet08, 4 },
	{ planeSet09, 8 },
	{ planeSet10, 6 },
	{ planeSet11, 8 },
	{ planeSet12, 6 },
	{ planeSet13, 8 },
	{ planeSet14, 6 },
	{ planeSet15, 6 },
	{ planeSet16, 4 },
	{ planeSet17, 6 },
	{ planeSet18, 8 },
	{ planeSet19, 8 },
	{ planeSet20, 6 },
	{ planeSet21, 6 },
	{ planeSet22, 8 },
	{ planeSet23, 6 },
	{ planeSet24, 6 },
	{ planeSet25, 8 },
	{ planeSet26, 8 },
	{ planeSet27, 8 },
	{ planeSet28, 6 },
	{ planeSet29, 6 },
	{ planeSet30, 6 },
	{ planeSet31, 4 },
	{ planeSet32, 4 },
	{ planeSet33, 6 },
	{ planeSet34, 6 },
	{ planeSet35, 6 },
	{ planeSet36, 8 },
	{ planeSet37, 8 },
	{ planeSet38, 8 },
	{ planeSet39, 6 },
	{ planeSet40, 6 },
	{ planeSet41, 8 },
	{ planeSet42, 6 },
	{ planeSet43, 6 },
	{ planeSet44, 8 },
	{ planeSet45, 8 },
	{ planeSet46, 6 },
	{ planeSet47, 4 },
	{ planeSet48, 6 },
	{ planeSet49, 6 },
	{ planeSet50, 8 },
	{ planeSet51, 6 },
	{ planeSet52, 8 },
	{ planeSet53, 6 },
	{ planeSet54, 8 },
	{ planeSet55, 4 },
	{ planeSet56, 6 },
	{ planeSet57, 6 },
	{ planeSet58, 6 },
	{ planeSet59, 4 },
	{ planeSet60, 6 },
	{ planeSet61, 4 },
	{ planeSet62, 4 },
	{ planeSet63, 0 } } ;
